diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuActivator.java b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuActivator.java
index 4495cfc63..ac4831969 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuActivator.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuActivator.java
@@ -7,6 +7,7 @@ import net.minecraft.core.crafting.ContainerListener;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.player.inventory.container.Container;
+import net.minecraft.core.player.inventory.container.ContainerInventory;
 import net.minecraft.core.player.inventory.slot.Slot;
 import org.jetbrains.annotations.NotNull;
 
@@ -14,11 +15,14 @@ public class MenuActivator extends MenuAbstract {
 	public static final int ID_SELECTOR = 0;
 	public static final int ID_LOCKED_SLOTS = 1;
 
-	public TileEntityActivator activator;
+	public static final int ACTIVATOR_INVENTORY_SIZE = 9;
+
+	public static final int ACTIVATOR_SLOTS_START = 0;
+	public static final int INVENTORY_SLOTS_START = ACTIVATOR_SLOTS_START + ACTIVATOR_INVENTORY_SIZE;
+	public static final int HOTBAR_SLOTS_START = INVENTORY_SLOTS_START + (ContainerInventory.MAIN_INVENTORY_SIZE - ContainerInventory.HOTBAR_SIZE);
 
-	private final int activatorSlotsStart;
-	private final int inventorySlotsStart;
-	private final int hotbarSlotsStart;
+
+	public TileEntityActivator activator;
 
 	private int selectorSlot;
 	private int lockedSlots;
@@ -29,19 +33,15 @@ public class MenuActivator extends MenuAbstract {
 			addSlot(new Slot(activator, i, 8 + i * 18, 35));
 		}
 
-		for (int j = 0; j < 3; j++) {
-			for (int i1 = 0; i1 < 9; i1++) {
-				addSlot(new Slot(container, i1 + j * 9 + 9, 8 + i1 * 18, 84 + j * 18));
+		for (int y = 0; y < (ContainerInventory.MAIN_INVENTORY_SIZE - ContainerInventory.HOTBAR_SIZE) / NUM_COLUMNS; y++) {
+			for (int x = 0; x < NUM_COLUMNS; x++) {
+				addSlot(new Slot(container, x + y * NUM_COLUMNS + ContainerInventory.HOTBAR_SIZE, 8 + x * 18, 84 + y * 18));
 			}
 		}
 
-		for (int k = 0; k < 9; k++) {
-			addSlot(new Slot(container, k, 8 + k * 18, 142));
+		for (int i = 0; i < ContainerInventory.HOTBAR_SIZE; i++) {
+			addSlot(new Slot(container, i, 8 + i * 18, 142));
 		}
-		
-		activatorSlotsStart = 0;
-		inventorySlotsStart = 9;
-		hotbarSlotsStart = 36;
 
 		selectorSlot = 0;
 		lockedSlots = 0;
@@ -87,21 +87,21 @@ public class MenuActivator extends MenuAbstract {
 
 	@Override
 	public IntList getMoveSlots(@NotNull InventoryAction action, @NotNull Slot slot, int target, Player player) {
-		if(slot.index >= activatorSlotsStart && slot.index < inventorySlotsStart) {
-			return getSlots(activatorSlotsStart, 9, false);
+		if(slot.index >= ACTIVATOR_SLOTS_START && slot.index < INVENTORY_SLOTS_START) {
+			return getSlots(ACTIVATOR_SLOTS_START, ACTIVATOR_INVENTORY_SIZE, false);
 		}
 		
 		if(action == InventoryAction.MOVE_ALL) {
-			if(slot.index >= inventorySlotsStart && slot.index < hotbarSlotsStart) {
-				return getSlots(inventorySlotsStart, 27, false);
+			if(slot.index >= INVENTORY_SLOTS_START && slot.index < HOTBAR_SLOTS_START) {
+				return getSlots(INVENTORY_SLOTS_START, (ContainerInventory.MAIN_INVENTORY_SIZE - ContainerInventory.HOTBAR_SIZE), false);
 			}
-			if(slot.index >= hotbarSlotsStart) {
-				return getSlots(hotbarSlotsStart, 9, false);
+			if(slot.index >= HOTBAR_SLOTS_START) {
+				return getSlots(HOTBAR_SLOTS_START, ContainerInventory.HOTBAR_SIZE, false);
 			}
 		}
 		if(action == InventoryAction.MOVE_SIMILAR) {
-			if(slot.index >= inventorySlotsStart) {
-				return getSlots(inventorySlotsStart, 36, false);
+			if(slot.index >= INVENTORY_SLOTS_START) {
+				return getSlots(INVENTORY_SLOTS_START, ContainerInventory.MAIN_INVENTORY_SIZE, false);
 			}
 		}
 		return null;
@@ -109,10 +109,10 @@ public class MenuActivator extends MenuAbstract {
 
 	@Override
 	public IntList getTargetSlots(@NotNull InventoryAction action, @NotNull Slot slot, int target, Player player) {
-		if(slot.index >= activatorSlotsStart && slot.index < inventorySlotsStart) {
-			return getSlots(inventorySlotsStart, 36, false);
+		if(slot.index >= ACTIVATOR_INVENTORY_SIZE && slot.index < INVENTORY_SLOTS_START) {
+			return getSlots(INVENTORY_SLOTS_START, ContainerInventory.MAIN_INVENTORY_SIZE, false);
 		}else {
-			return getSlots(activatorSlotsStart, 9, false);
+			return getSlots(ACTIVATOR_SLOTS_START, ACTIVATOR_INVENTORY_SIZE, false);
 		}
 	}
 }
diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuContainer.java b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuContainer.java
index 2eab6553e..b89ba7873 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuContainer.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuContainer.java
@@ -4,34 +4,34 @@ import it.unimi.dsi.fastutil.ints.IntList;
 import net.minecraft.core.InventoryAction;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.player.inventory.container.Container;
+import net.minecraft.core.player.inventory.container.ContainerInventory;
 import net.minecraft.core.player.inventory.slot.Slot;
 import org.jetbrains.annotations.NotNull;
 
 public class MenuContainer extends MenuAbstract {
-	
 	private Container container;
 	private int numberOfRows;
 	
 	public MenuContainer(Container playerContainer, Container container) {
 		this.container = container;
-		numberOfRows = container.getContainerSize() / 9;
-		int i = (numberOfRows - 4) * 18;
-		for (int j = 0; j < numberOfRows; j++) {
-			for (int i1 = 0; i1 < 9; i1++) {
-				addSlot(new Slot(container, i1 + j * 9, 8 + i1 * 18, 18 + j * 18));
+		numberOfRows = container.getContainerSize() / NUM_COLUMNS;
+		int playerInventoryYOffset = (numberOfRows - 4) * 18;
+		for (int y = 0; y < numberOfRows; y++) {
+			for (int x = 0; x < NUM_COLUMNS; x++) {
+				addSlot(new Slot(container, x + y * NUM_COLUMNS, 8 + x * 18, 18 + y * 18));
 			}
 
 		}
 
-		for (int k = 0; k < 3; k++) {
-			for (int j1 = 0; j1 < 9; j1++) {
-				addSlot(new Slot(playerContainer, j1 + k * 9 + 9, 8 + j1 * 18, 103 + k * 18 + i));
+		for (int y = 0; y < (ContainerInventory.MAIN_INVENTORY_SIZE - ContainerInventory.HOTBAR_SIZE) / NUM_COLUMNS; y++) {
+			for (int x = 0; x < NUM_COLUMNS; x++) {
+				addSlot(new Slot(playerContainer, x + y * NUM_COLUMNS + ContainerInventory.HOTBAR_SIZE, 8 + x * 18, 103 + y * 18 + playerInventoryYOffset));
 			}
 
 		}
 
-		for (int l = 0; l < 9; l++) {
-			addSlot(new Slot(playerContainer, l, 8 + l * 18, 161 + i));
+		for (int i = 0; i < ContainerInventory.HOTBAR_SIZE; i++) {
+			addSlot(new Slot(playerContainer, i, 8 + i * 18, 161 + playerInventoryYOffset));
 		}
 
 	}
@@ -43,7 +43,7 @@ public class MenuContainer extends MenuAbstract {
 	
 	@Override
 	public IntList getMoveSlots(@NotNull InventoryAction action, @NotNull Slot slot, int target, Player player) {
-		int chestSize = numberOfRows * 9;
+		int chestSize = numberOfRows * NUM_COLUMNS;
 		
 		if(slot.index >= 0 && slot.index < chestSize) {
 			// Chest inventory
@@ -51,18 +51,18 @@ public class MenuContainer extends MenuAbstract {
 		}
 		
 		if(action == InventoryAction.MOVE_ALL) {
-			if(slot.index >= chestSize && slot.index < chestSize + 27) {
+			if(slot.index >= chestSize && slot.index < chestSize + (ContainerInventory.MAIN_INVENTORY_SIZE - ContainerInventory.HOTBAR_SIZE)) {
 				// Main ContainerInventory
-				return getSlots(chestSize, 27, false);
+				return getSlots(chestSize, (ContainerInventory.MAIN_INVENTORY_SIZE - ContainerInventory.HOTBAR_SIZE), false);
 			}
-			if(slot.index >= chestSize + 27 && slot.index < chestSize + 36) {
+			if(slot.index >= chestSize + (ContainerInventory.MAIN_INVENTORY_SIZE - ContainerInventory.HOTBAR_SIZE) && slot.index < chestSize + ContainerInventory.MAIN_INVENTORY_SIZE) {
 				// Hotbar
-				return getSlots(chestSize + 27, 9, false);
+				return getSlots(chestSize + (ContainerInventory.MAIN_INVENTORY_SIZE - ContainerInventory.HOTBAR_SIZE), ContainerInventory.HOTBAR_SIZE, false);
 			}
 		}else {
-			if(slot.index >= chestSize && slot.index < chestSize + 36) {
+			if(slot.index >= chestSize && slot.index < chestSize + ContainerInventory.MAIN_INVENTORY_SIZE) {
 				// Full ContainerInventory
-				return getSlots(chestSize, 36, false);
+				return getSlots(chestSize, ContainerInventory.MAIN_INVENTORY_SIZE, false);
 			}
 		}
 		
@@ -71,11 +71,11 @@ public class MenuContainer extends MenuAbstract {
 
 	@Override
 	public IntList getTargetSlots(@NotNull InventoryAction action, @NotNull Slot slot, int target, Player player) {
-		int chestSize = numberOfRows * 9;
+		int chestSize = numberOfRows * NUM_COLUMNS;
 		
 		if(slot.index < chestSize) {
 			// Clicked chest
-			return getSlots(chestSize, 36, true); // ContainerInventory
+			return getSlots(chestSize, ContainerInventory.MAIN_INVENTORY_SIZE, true); // ContainerInventory
 		}else {
 			// Clicked ContainerInventory
 			return getSlots  (0, chestSize, false); // Chest
diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuCrafting.java b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuCrafting.java
index dc27d2b6b..a1ba6266b 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuCrafting.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuCrafting.java
@@ -18,33 +18,44 @@ import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 
 public class MenuCrafting extends MenuAbstract {
+    private static final int NUM_CRAFTING_COLUMNS = 3;
+    private static final int NUM_CRAFTING_ROWS = 3;
+    private static final int NUM_RESULT_SLOTS = 1;
+
+    private static final int RESULT_SLOTS_START = 0;
+    private static final int CRAFTING_SLOTS_START = RESULT_SLOTS_START + NUM_RESULT_SLOTS;
+    private static final int INVENTORY_SLOTS_START = CRAFTING_SLOTS_START + (NUM_CRAFTING_COLUMNS * NUM_CRAFTING_ROWS);
+    private static final int HOTBAR_SLOTS_START = INVENTORY_SLOTS_START + (ContainerInventory.MAIN_INVENTORY_SIZE - ContainerInventory.HOTBAR_SIZE);
+
     public final @NotNull ContainerCrafting craftSlots;
     public final @NotNull Container resultSlots;
     private final @NotNull World world;
     private final @NotNull TilePos tilePos;
 
     public MenuCrafting(@NotNull ContainerInventory inventory, @NotNull World world, @NotNull TilePosc tilePos) {
-        this.craftSlots = new ContainerCrafting(this, 3, 3);
+        this.craftSlots = new ContainerCrafting(this, NUM_CRAFTING_COLUMNS, NUM_CRAFTING_ROWS);
         this.resultSlots = new ContainerResult();
         this.world = world;
         this.tilePos = new TilePos(tilePos);
+
         addSlot(new SlotResult(inventory.player, this.craftSlots, this.resultSlots, 0, 124, 35));
-        for (int l = 0; l < 3; l++) {
-            for (int k1 = 0; k1 < 3; k1++) {
-                addSlot(new Slot(this.craftSlots, k1 + l * 3, 30 + k1 * 18, 17 + l * 18));
+
+        for (int y = 0; y < NUM_CRAFTING_ROWS; y++) {
+            for (int x = 0; x < NUM_CRAFTING_COLUMNS; x++) {
+                addSlot(new Slot(this.craftSlots, x + y * NUM_CRAFTING_COLUMNS, 30 + x * 18, 17 + y * 18));
             }
 
         }
 
-        for (int i1 = 0; i1 < 3; i1++) {
-            for (int l1 = 0; l1 < 9; l1++) {
-                addSlot(new Slot(inventory, l1 + i1 * 9 + 9, 8 + l1 * 18, 84 + i1 * 18));
+        for (int y = 0; y < (ContainerInventory.MAIN_INVENTORY_SIZE - ContainerInventory.HOTBAR_SIZE) / NUM_COLUMNS; y++) {
+            for (int x = 0; x < 9; x++) {
+                addSlot(new Slot(inventory, x + y * NUM_COLUMNS + ContainerInventory.HOTBAR_SIZE, 8 + x * 18, 84 + y * 18));
             }
 
         }
 
-        for (int j1 = 0; j1 < 9; j1++) {
-            addSlot(new Slot(inventory, j1, 8 + j1 * 18, 142));
+        for (int i = 0; i < ContainerInventory.HOTBAR_SIZE; i++) {
+            addSlot(new Slot(inventory, i, 8 + i * 18, 142));
         }
 
         slotsChanged(this.craftSlots);
@@ -90,27 +101,27 @@ public class MenuCrafting extends MenuAbstract {
 
     @Override
     public IntList getMoveSlots(@NotNull InventoryAction action, @NotNull Slot slot, int target, Player player) {
-        if (slot.index == 0) {
+        if (slot.index >= RESULT_SLOTS_START && slot.index < CRAFTING_SLOTS_START) {
             // Craft Result
-            return getSlots(0, 1, false);
+            return getSlots(RESULT_SLOTS_START, NUM_RESULT_SLOTS, false);
         }
-        if (slot.index >= 1 && slot.index < 9) {
+        if (slot.index >= CRAFTING_SLOTS_START && slot.index < INVENTORY_SLOTS_START) {
             // Crafting Grid
-            return getSlots(1, 9, false);
+            return getSlots(CRAFTING_SLOTS_START, NUM_CRAFTING_COLUMNS * NUM_CRAFTING_ROWS, false);
         }
         if (action == InventoryAction.MOVE_SIMILAR) {
-            if (slot.index >= 10 && slot.index <= 45) {
+            if (slot.index >= INVENTORY_SLOTS_START && slot.index < HOTBAR_SLOTS_START + ContainerInventory.HOTBAR_SIZE) {
                 // Full ContainerInventory
-                return getSlots(10, 36, false);
+                return getSlots(INVENTORY_SLOTS_START, ContainerInventory.MAIN_INVENTORY_SIZE, false);
             }
         } else {
-            if (slot.index >= 10 && slot.index <= 36) {
+            if (slot.index >= INVENTORY_SLOTS_START && slot.index <= HOTBAR_SLOTS_START) {
                 // Main ContainerInventory
-                return getSlots(10, 27, false);
+                return getSlots(INVENTORY_SLOTS_START, (ContainerInventory.MAIN_INVENTORY_SIZE - ContainerInventory.HOTBAR_SIZE), false);
             }
-            if (slot.index >= 37 && slot.index <= 45) {
+            if (slot.index >= HOTBAR_SLOTS_START && slot.index < HOTBAR_SLOTS_START + ContainerInventory.HOTBAR_SIZE) {
                 // Hotbar
-                return getSlots(37, 9, false);
+                return getSlots(HOTBAR_SLOTS_START, ContainerInventory.HOTBAR_SIZE, false);
             }
         }
         return null;
@@ -118,27 +129,27 @@ public class MenuCrafting extends MenuAbstract {
 
     @Override
     public IntList getTargetSlots(@NotNull InventoryAction action, @NotNull Slot slot, int target, Player player) {
-        if (slot.index >= 10 && slot.index <= 45) {
+        if (slot.index >= INVENTORY_SLOTS_START && slot.index < HOTBAR_SLOTS_START + ContainerInventory.HOTBAR_SIZE) {
             // Full ContainerInventory
             if (target == 1) {
-                return getSlots(1, 9, false); // To Crafting Grid
+                return getSlots(CRAFTING_SLOTS_START, NUM_CRAFTING_COLUMNS * NUM_CRAFTING_ROWS, false); // To Crafting Grid
             }
-            if (slot.index >= 10 && slot.index <= 36) {
+            if (slot.index >= INVENTORY_SLOTS_START && slot.index < HOTBAR_SLOTS_START) {
                 // Main ContainerInventory
-                return getSlots(37, 9, false); // To Hotbar
+                return getSlots(HOTBAR_SLOTS_START, ContainerInventory.HOTBAR_SIZE, false); // To Hotbar
             }
-            if (slot.index >= 37 && slot.index <= 45) {
+            if (slot.index >= HOTBAR_SLOTS_START && slot.index < HOTBAR_SLOTS_START + ContainerInventory.HOTBAR_SIZE) {
                 // Hotbar
-                return getSlots(10, 27, false); // To Main ContainerInventory
+                return getSlots(INVENTORY_SLOTS_START, (ContainerInventory.MAIN_INVENTORY_SIZE - ContainerInventory.HOTBAR_SIZE), false); // To Main ContainerInventory
             }
         } else {
             // Crafting grid or result
-            if (slot.index == 0) {
+            if (slot.index == RESULT_SLOTS_START) {
                 // Crafting Result
-                return getSlots(10, 36, true);
+                return getSlots(INVENTORY_SLOTS_START, ContainerInventory.MAIN_INVENTORY_SIZE, true);
             } else {
                 // Crafting Grid
-                return getSlots(10, 36, false);
+                return getSlots(INVENTORY_SLOTS_START, ContainerInventory.MAIN_INVENTORY_SIZE, false);
             }
         }
 
diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuDispenser.java b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuDispenser.java
new file mode 100644
index 000000000..3f6df7cb3
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuDispenser.java
@@ -0,0 +1,79 @@
+package net.minecraft.core.player.inventory.menu;
+
+import it.unimi.dsi.fastutil.ints.IntList;
+import net.minecraft.core.InventoryAction;
+import net.minecraft.core.block.entity.TileEntityDispenser;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.player.inventory.container.Container;
+import net.minecraft.core.player.inventory.container.ContainerInventory;
+import net.minecraft.core.player.inventory.slot.Slot;
+import org.jetbrains.annotations.NotNull;
+
+public class MenuDispenser extends MenuAbstract {
+
+
+	private static final int NUM_DISPENSER_COLUMNS = 3;
+	private static final int NUM_DISPENSER_ROWS = 3;
+
+	private static final int DISPENSER_SLOTS_START = 0;
+	private static final int INVENTORY_SLOTS_START = DISPENSER_SLOTS_START + (NUM_DISPENSER_COLUMNS * NUM_DISPENSER_ROWS);
+	private static final int HOTBAR_SLOTS_START = INVENTORY_SLOTS_START + (ContainerInventory.MAIN_INVENTORY_SIZE - ContainerInventory.HOTBAR_SIZE);
+
+	public TileEntityDispenser dispenser;
+
+	public MenuDispenser(Container container, TileEntityDispenser dispenser) {
+		this.dispenser = dispenser;
+		for (int y = 0; y < NUM_DISPENSER_ROWS; y++) {
+			for (int x = 0; x < NUM_DISPENSER_COLUMNS; x++) {
+				addSlot(new Slot(dispenser, x + y * NUM_DISPENSER_COLUMNS, 62 + x * 18, 17 + y * 18));
+			}
+
+		}
+
+		for (int y = 0; y < (ContainerInventory.MAIN_INVENTORY_SIZE - ContainerInventory.HOTBAR_SIZE) / NUM_COLUMNS; y++) {
+			for (int x = 0; x < NUM_COLUMNS; x++) {
+				addSlot(new Slot(container, x + y * NUM_COLUMNS + ContainerInventory.HOTBAR_SIZE, 8 + x * 18, 84 + y * 18));
+			}
+		}
+
+		for (int i = 0; i < ContainerInventory.HOTBAR_SIZE; i++) {
+			addSlot(new Slot(container, i, 8 + i * 18, 142));
+		}
+	}
+	
+	@Override
+	public boolean stillValid(@NotNull Player player) {
+		return dispenser.stillValid(player);
+	}
+
+	@Override
+	public IntList getMoveSlots(@NotNull InventoryAction action, @NotNull Slot slot, int target, Player player) {
+		if(slot.index >= DISPENSER_SLOTS_START && slot.index < INVENTORY_SLOTS_START) {
+			return getSlots(DISPENSER_SLOTS_START, NUM_DISPENSER_COLUMNS * NUM_DISPENSER_ROWS, false);
+		}
+		
+		if(action == InventoryAction.MOVE_ALL) {
+			if(slot.index >= INVENTORY_SLOTS_START && slot.index < HOTBAR_SLOTS_START) {
+				return getSlots(INVENTORY_SLOTS_START, ContainerInventory.MAIN_INVENTORY_SIZE - ContainerInventory.HOTBAR_SIZE, false);
+			}
+			if(slot.index >= HOTBAR_SLOTS_START) {
+				return getSlots(HOTBAR_SLOTS_START, ContainerInventory.HOTBAR_SIZE, false);
+			}
+		}
+		if(action == InventoryAction.MOVE_SIMILAR) {
+			if(slot.index >= INVENTORY_SLOTS_START) {
+				return getSlots(INVENTORY_SLOTS_START, ContainerInventory.MAIN_INVENTORY_SIZE, false);
+			}
+		}
+		return null;
+	}
+
+	@Override
+	public IntList getTargetSlots(@NotNull InventoryAction action, @NotNull Slot slot, int target, Player player) {
+		if(slot.index >= DISPENSER_SLOTS_START && slot.index < INVENTORY_SLOTS_START) {
+			return getSlots(INVENTORY_SLOTS_START, ContainerInventory.MAIN_INVENTORY_SIZE, false);
+		}else {
+			return getSlots(DISPENSER_SLOTS_START, NUM_DISPENSER_COLUMNS * NUM_DISPENSER_ROWS, false);
+		}
+	}
+}
diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuFlag.java b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuFlag.java
index ca8ba176d..393fc9003 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuFlag.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuFlag.java
@@ -5,30 +5,37 @@ import net.minecraft.core.InventoryAction;
 import net.minecraft.core.block.entity.TileEntityFlag;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.player.inventory.container.Container;
+import net.minecraft.core.player.inventory.container.ContainerInventory;
 import net.minecraft.core.player.inventory.slot.Slot;
 import net.minecraft.core.player.inventory.slot.SlotDye;
 import org.jetbrains.annotations.NotNull;
 
 public class MenuFlag extends MenuAbstract {
+	private static final int NUM_DYE_SLOTS = 3;
+
+	private static final int DYE_SLOTS_START = 0;
+	private static final int INVENTORY_SLOTS_START = DYE_SLOTS_START + NUM_DYE_SLOTS;
+	private static final int HOTBAR_SLOTS_START = INVENTORY_SLOTS_START + (ContainerInventory.MAIN_INVENTORY_SIZE - ContainerInventory.HOTBAR_SIZE);
+
 	public TileEntityFlag flag;
 
 	public MenuFlag(Container inv, TileEntityFlag flag) {
 		this.flag = flag;
 
 		// Dye slots
-		addSlot(new SlotDye(flag, 36, 129, 10));
-		addSlot(new SlotDye(flag, 37, 129, 32));
-		addSlot(new SlotDye(flag, 38, 129, 54));
+		for (int i = 0; i < NUM_DYE_SLOTS; i++) {
+			addSlot(new SlotDye(flag, i, 129, 10 + 22 * i));
+		}
 
 		// Player inv slots
-		for (int y = 0; y < 3; y++) {
-			for (int x = 0; x < 9; x++) {
-				addSlot(new Slot(inv, x + y * 9 + 9, 8 + x * 18, 113 + y * 18));
+		for (int y = 0; y < (ContainerInventory.MAIN_INVENTORY_SIZE - ContainerInventory.HOTBAR_SIZE) / NUM_COLUMNS; y++) {
+			for (int x = 0; x < NUM_COLUMNS; x++) {
+				addSlot(new Slot(inv, x + y * NUM_COLUMNS + ContainerInventory.HOTBAR_SIZE, 8 + x * 18, 113 + y * 18));
 			}
 		}
 
 		// Player hotbar
-		for (int i = 0; i < 9; i++) {
+		for (int i = 0; i < ContainerInventory.HOTBAR_SIZE; i++) {
 			addSlot(new Slot(inv, i, 8 + i * 18, 171));
 		}
 	}
@@ -40,21 +47,21 @@ public class MenuFlag extends MenuAbstract {
 	 */
 	@Override
 	public IntList getMoveSlots(@NotNull InventoryAction action, @NotNull Slot slot, int target, Player player) {
-		if(slot.index >= 0 && slot.index <= 2) {
+		if(slot.index >= DYE_SLOTS_START && slot.index < INVENTORY_SLOTS_START) {
 			// Dye Slots
-			return getSlots(0, 3, false);
+			return getSlots(DYE_SLOTS_START, NUM_DYE_SLOTS, false);
 		}
 		if(action == InventoryAction.MOVE_SIMILAR) {
 			// Full ContainerInventory
-			return getSlots(3, 36, false);
+			return getSlots(INVENTORY_SLOTS_START, ContainerInventory.MAIN_INVENTORY_SIZE, false);
 		}
 		if(action == InventoryAction.MOVE_ALL) {
-			if(slot.index < 27) {
+			if(slot.index < HOTBAR_SLOTS_START) {
 				// Main ContainerInventory
-				return getSlots(3, 27, false);
+				return getSlots(INVENTORY_SLOTS_START, ContainerInventory.MAIN_INVENTORY_SIZE - ContainerInventory.HOTBAR_SIZE, false);
 			}else {
 				// Hotbar
-				return getSlots(30, 9, false);
+				return getSlots(HOTBAR_SLOTS_START, ContainerInventory.HOTBAR_SIZE, false);
 			}
 		}
 		return null;
@@ -62,11 +69,11 @@ public class MenuFlag extends MenuAbstract {
 
 	@Override
 	public IntList getTargetSlots(@NotNull InventoryAction action, @NotNull Slot slot, int target, Player player) {
-		if(slot.index >= 0 && slot.index <= 2) {
+		if(slot.index >= DYE_SLOTS_START && slot.index < INVENTORY_SLOTS_START) {
 			// Dye Slots
-			return getSlots(3, 36, false); // Into ContainerInventory
+			return getSlots(INVENTORY_SLOTS_START, ContainerInventory.MAIN_INVENTORY_SIZE, false); // Into ContainerInventory
 		}
-		return getSlots(0, 3, false); // Dye Slots
+		return getSlots(DYE_SLOTS_START, NUM_DYE_SLOTS, false); // Dye Slots
 	}
 
 	@Override
diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuFurnace.java b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuFurnace.java
index 26ce3aa02..201ccc0c3 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuFurnace.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuFurnace.java
@@ -16,30 +16,36 @@ public class MenuFurnace extends MenuAbstract {
 	public static final int ID_MAX_COOK_TIME = 2;
 	public static final int ID_MAX_BURN_TIME = 3;
 
+	private static final int NUM_INGREDIENT_SLOTS = 1;
+	private static final int NUM_FUEL_SLOTS = 1;
+	private static final int NUM_RESULT_SLOTS = 1;
+
+	private static final int INGREDIENT_SLOTS_START = 0;
+	private static final int FUEL_SLOTS_START = INGREDIENT_SLOTS_START + NUM_INGREDIENT_SLOTS;
+	private static final int RESULT_SLOTS_START = FUEL_SLOTS_START + NUM_FUEL_SLOTS;
+	private static final int INVENTORY_SLOTS_START = RESULT_SLOTS_START + NUM_RESULT_SLOTS;
+	private static final int HOTBAR_SLOTS_START = INVENTORY_SLOTS_START + (ContainerInventory.MAIN_INVENTORY_SIZE - ContainerInventory.HOTBAR_SIZE);
+
 	public TileEntityFurnace furnace;
-	private int currentCookTime;
-	private int currentBurnTime;
-	private int itemBurnTime;
-	private int itemCookTime;
+	private int currentCookTime = 0;
+	private int currentBurnTime = 0;
+	private int itemBurnTime = 0;
+	private int itemCookTime = 0;
 
 	public MenuFurnace(ContainerInventory inventory, TileEntityFurnace tileEntity) {
-		currentCookTime = 0;
-		currentBurnTime = 0;
-		itemCookTime = 0;
-		itemBurnTime = 0;
 		furnace = tileEntity;
-		addSlot(new Slot(tileEntity, 0, 56, 17));
-		addSlot(new Slot(tileEntity, 1, 56, 53));
-		addSlot(new SlotFurnace(inventory.player, tileEntity, 2, 116, 35));
-		for (int i = 0; i < 3; i++) {
-			for (int k = 0; k < 9; k++) {
-				addSlot(new Slot(inventory, k + i * 9 + 9, 8 + k * 18, 84 + i * 18));
-			}
+		addSlot(new Slot(tileEntity, TileEntityFurnace.SLOT_INGREDIENT, 56, 17));
+		addSlot(new Slot(tileEntity, TileEntityFurnace.SLOT_FUEL, 56, 53));
+		addSlot(new SlotFurnace(inventory.player, tileEntity, TileEntityFurnace.SLOT_RESULT, 116, 35));
 
+		for (int y = 0; y < (ContainerInventory.MAIN_INVENTORY_SIZE - ContainerInventory.HOTBAR_SIZE) / NUM_COLUMNS; y++) {
+			for (int x = 0; x < NUM_COLUMNS; x++) {
+				addSlot(new Slot(inventory, x + y * NUM_COLUMNS + ContainerInventory.HOTBAR_SIZE, 8 + x * 18, 84 + y * 18));
+			}
 		}
 
-		for (int j = 0; j < 9; j++) {
-			addSlot(new Slot(inventory, j, 8 + j * 18, 142));
+		for (int i = 0; i < ContainerInventory.HOTBAR_SIZE; i++) {
+			addSlot(new Slot(inventory, i, 8 + i * 18, 142));
 		}
 
 	}
@@ -101,53 +107,61 @@ public class MenuFurnace extends MenuAbstract {
 
 	@Override
 	public IntList getMoveSlots(@NotNull InventoryAction action, @NotNull Slot slot, int target, Player player) {
-		if(slot.index >= 0 && slot.index <= 3) return getSlots(slot.index, 1, false);
+		if (slot.index >= INGREDIENT_SLOTS_START && slot.index < FUEL_SLOTS_START) {
+            return getSlots(INGREDIENT_SLOTS_START, NUM_INGREDIENT_SLOTS, false);
+        }
+		if (slot.index >= FUEL_SLOTS_START && slot.index < RESULT_SLOTS_START) {
+			return getSlots(FUEL_SLOTS_START, NUM_FUEL_SLOTS, false);
+		}
+		if (slot.index >= RESULT_SLOTS_START && slot.index < INVENTORY_SLOTS_START) {
+			return getSlots(RESULT_SLOTS_START, NUM_RESULT_SLOTS, false);
+		}
 
 		if(action == InventoryAction.MOVE_ALL) {
-			if(slot.index >= 3 && slot.index <= 30) {
+			if(slot.index >= INVENTORY_SLOTS_START && slot.index < HOTBAR_SLOTS_START) {
 				// Main ContainerInventory
-				return getSlots(3, 27, false);
+				return getSlots(INVENTORY_SLOTS_START, ContainerInventory.MAIN_INVENTORY_SIZE - ContainerInventory.HOTBAR_SIZE, false);
 			}
-			if(slot.index >= 30 && slot.index <= 38) {
+			if(slot.index >= HOTBAR_SLOTS_START && slot.index < HOTBAR_SLOTS_START + ContainerInventory.HOTBAR_SIZE) {
 				// Hotbar
-				return getSlots(30, 9, false);
+				return getSlots(HOTBAR_SLOTS_START, ContainerInventory.HOTBAR_SIZE, false);
 			}
 		}
-		if(slot.index >= 3 && slot.index <= 38) {
+		if(slot.index >= INVENTORY_SLOTS_START && slot.index < INVENTORY_SLOTS_START + ContainerInventory.MAIN_INVENTORY_SIZE) {
 			// Full ContainerInventory
-			return getSlots(3, 36, false);
+			return getSlots(INVENTORY_SLOTS_START, ContainerInventory.MAIN_INVENTORY_SIZE, false);
 		}
 		return null;
 	}
 
 	@Override
 	public IntList getTargetSlots(@NotNull InventoryAction action, @NotNull Slot slot, int target, Player player) {
-		if(slot.index >= 3 && slot.index <= 39) {
+		if(slot.index >= INVENTORY_SLOTS_START && slot.index <= INVENTORY_SLOTS_START + ContainerInventory.MAIN_INVENTORY_SIZE) {
 			// Full ContainerInventory
 			if(action != InventoryAction.MOVE_ALL) {
 				if(target == 1) {
-					return getSlots(0, 1, false); // Into Ingredient Slot
+					return getSlots(INGREDIENT_SLOTS_START, NUM_INGREDIENT_SLOTS, false); // Into Ingredient Slot
 				}
 				if(target == 2) {
-					return getSlots(1, 1, false); // Into Fuel Slot
+					return getSlots(FUEL_SLOTS_START, NUM_FUEL_SLOTS, false); // Into Fuel Slot
 				}
 			}
-			if(slot.index >= 3 && slot.index <= 29) {
+			if(slot.index >= INVENTORY_SLOTS_START && slot.index < HOTBAR_SLOTS_START) {
 				// Main ContainerInventory
-				return getSlots(30, 9, false); // Into Hotbar
+				return getSlots(HOTBAR_SLOTS_START, ContainerInventory.HOTBAR_SIZE, false); // Into Hotbar
 			}
-			if(slot.index >= 31 && slot.index <= 38) {
+			if(slot.index >= HOTBAR_SLOTS_START && slot.index < HOTBAR_SLOTS_START + ContainerInventory.HOTBAR_SIZE) {
 				// Hotbar
-				return getSlots(3, 27, false); // Into Main ContainerInventory
+				return getSlots(INVENTORY_SLOTS_START, ContainerInventory.MAIN_INVENTORY_SIZE - ContainerInventory.HOTBAR_SIZE, false); // Into Main ContainerInventory
 			}
 		}
-		if(slot.index >= 0 && slot.index <= 2) {
-			if(slot.index == 2) {
+		if(slot.index >= INGREDIENT_SLOTS_START && slot.index < INVENTORY_SLOTS_START) {
+			if(slot.index == RESULT_SLOTS_START) {
 				// Output
-				return getSlots(3, 36, true);
+				return getSlots(INVENTORY_SLOTS_START, ContainerInventory.MAIN_INVENTORY_SIZE, true);
 			}else {
 				// Input and Fuel
-				return getSlots(3, 36, false);
+				return getSlots(INVENTORY_SLOTS_START, ContainerInventory.MAIN_INVENTORY_SIZE, false);
 			}
 		}
 
